;       COLOR   equ     0       ; monochrome LCD-display
        COLOR   equ     1       ; color screen

	COMMENT *
----------------------------------------------------------------
----------------------------------------------------------------
This is how to assemble:
(NOTE: options are case sensitive!)

MASM:
-----
ML /AT /c PARmon.ASM
LINK PARmon.obj,PARmon.COM,,, /TINY
DEL PARmon.map PARmon.obj

TASM:
-----
TASM /oi /zn PARmon.ASM
TLINK /x /3 /t PARmon.obj,PARmon.COM
DEL PARmon.obj
----------------------------------------------------------------
----------------------------------------------------------------
	*

	TITLE   PARport MONITOR V1.02

	BlankTimer      equ     3       ; seconds after mouse-cursor is blanked


	.MODEL	TINY
	.CODE

	.386
SEGALL  SEGMENT USE16
	ASSUME CS:SEGALL, DS:SEGALL

	STARTLOCATION   equ     100h    ; .COM-file

; here goes the non initialized
; data, which then overwrites
; the startup code to save a few
; bytes...

USPACE  STRUC
	Mbutton	DW	?		; button state
	PORT    DW      ?               ; address of selected PARport
	breakf	DB	?		; DOS break-flag
	MOUSE	DB	?		; -1 if mouse is installed, 0 else
	BLINK	DB	?		; old value of blinking flag
	COLORMA DB	16*3 DUP (?)	; old colormap			& space for state information (64 byte)
	PALETTA DB	17   DUP (?)	; buffer for palette and border &   "   " ...
	CURSOR	DW	?		; cursor size
	VPAGE	DB	?		; video page
	OLDmode DB	?		; old video mode
	X	DW	?		; horiz. position
	Y       DW    	?               ; vert. mouse position
	MOUSEI  DD 	?               ; far pointer to previous user interrupt
	STATUS  DD   	?               ; port status
	PREPORT DD   	?               ; previous port status
	CHANGED DD   	?               ; bits that changed
	MOUSEIM DW    	?               ; previous user interrupt mask
	STACKSP DW	96   DUP (?)	; here goes the new stack
	STACKTP DW	?
USPACE	ENDS

	ORG     STARTLOCATION
OVERWR  USPACE  <>

;
;	DO NOT CHANGE OFFSET OR MOUSE-CLICKS WILL GO TO PAMPAS!
;	(dropped this due to optimizations;)
;
	XO      equ     8               ; x-offset (1 as fixed position)
	YO      equ     1               ; y-offset           "

;
;	DON'T EDIT THIS! CHANGE COLORMAP (BOTTOM) INSTEAD...
;
	titlecolor	equ	12h	; color for the title
	background	equ	00h	; default background color
	high5		equ	34h	; color for +5V (high)
	low0		equ	56h	; color for -0V (ground)
	notcare 	equ	78h	; color for "don't cares"
	gndcolor	equ	79h	; color for "GND"
	shortcut	equ	0ABh	; color for shortcut keys
	dattxtcolor	equ	0CDh	; color for data-txt
	esccolor	equ	0EFh	; color for ESC-txt

	ORG     80h                     ; location of argument count + argument
ARGUMENT LABEL WORD                     ; portnumber - '1' (default),'2' or '3'

	ORG     STARTLOCATION
START   PROC    NEAR
	XOR     AX,AX                   ; clear AX
	MOV     FS,AX                   ; and FS
	MOV	OVERWR.Mbutton,AX	; for compability with old TASM :-P
	MOV     DL,BYTE PTR ARGUMENT    ; check for more than one argument
	CMP     DL,2                    ; Arg. to long or too many args?
	JG      CMDerr                  ; Too many args!
	TEST    DL,DL                   ; Do we have an argument?
	JZ      NO_ARG                  ; no
	MOV     AL,BYTE PTR ARGUMENT+2  ; get argument
	XOR     AL,'0'                  ; convert ASCii to hex
	CMP     AL,1
	JL      CMDerr                  ; only parms
	CMP     AL,3                    ; between 1 and 3 (inclusive;)
	JG      CMDerr                  ; are valid
	DEC     AL                      ; 1 becomes 0 index
NO_ARG: MOV     BL,AL
	ADD     BL,'0'+1                ; rebuild port number
	MOV     PORTNR,BL
	SHL     AX,1                    ; multiply AX by 2 as BIOS contains WORDs
	MOV     BX,408h                 ; PARports in BIOS
	ADD     BX,AX                   ; add to get selected PARport
	MOV     AX,FS:[BX]              ; retrieve PORT
	LEA     DX,wrPtxt               ; text for port error
	TEST    AX,AX
	JZ      wrPORT                  ; no such PORT!
	MOV     OVERWR.PORT,AX          ; store PORT address

	MOV     AX,3300h                ; get break-flag
	INT     21h
	MOV     OVERWR.breakf,DL
	INC     AX
	XOR     DL,DL
	INT     21h                     ; clear break-flag

	MOV	AH,0Fh			; get video state
	INT     10h
	MOV     OVERWR.OLDmode,AL       ; current video mode
	MOV     OVERWR.VPAGE,BH         ; current display page
	MOV     AH,3                    ; get cursor size
	INT     10h
	MOV     OVERWR.CURSOR,CX        ; current cursor size

	MOV	AH,1Bh			; get state information
	XOR	BX,BX
	LEA	DI,OVERWR.COLORMA	; 64 byte buffer
	INT	10h
	MOV	AH,[FS:465h]		; blink-flag prior VGA
	CMP	AL,1Bh			; Is function supported?
	JNE	nosupp			; Nope, sorry - not my fault!
	MOV	AH,[DI+2Dh]		; blink-flag
nosupp:	MOV	OVERWR.BLINK,AH

	MOV	AX,1017h		; get old color registers
;	XOR	BX,BX
	MOV	CX,16			; number of color registers
	MOV	DX,DI			; 16*3 bytes for all colors
	INT	10h

	MOV	AX,1009h		; get palette and border
	LEA	DX,OVERWR.PALETTA	; 17 bytes for palette(16)+border
	INT	10h

	MOV	AX,0002h		; screen mode 80x25-16colors
	INT     10h

	MOV	AX,1003h		; toggle blink-flag
;	MOV	BL,0			; set to intensity rather than blinking
	INT	10h

	MOV	AX,1012h		; set colors
;	XOR	BX,BX
;	MOV	CX,16			; set color registers
	MOV	DX,OFFSET COLORMP
	INT	10h

	MOV	AX,1002h		; set palette and border
	MOV	DX,OFFSET PALETTE
	INT	10h

	MOV	AH,1			; set cursor
	MOV     CX,2000h                ; disabled
	INT	10h

	MOV     AX,0920h                ; blank whole screen
	MOV	BH,OVERWR.VPAGE
	MOV     BL,background           ; attribute to use
	MOV     CX,80*25                ; number of chars to write
	INT     10h

	XOR     DX,DX
	MOV     AX,1300h                ; write string
;       MOV     BH,OVERWR.VPAGE
	MOV	BL,titlecolor
	MOV     CX,TITLEEND-PTITLE
	LEA     BP,PTITLE
	INT     10h                     ; print title line

	;            Y        X
	MOV     DX,(24)*256+(60)
;       MOV     AX,1300h                ; write string
;       MOV     BH,OVERWR.VPAGE
	MOV     BL,esccolor
	MOV     CX,ESCEND-ESCTXT
	LEA     BP,ESCTXT
	INT     10h                     ; print "ESC" line

	;             Y           X
	MOV     DX,(YO+2)*256+(XO+8)
;	MOV	AX,1300h		; write string
;       MOV     BH,OVERWR.VPAGE
	MOV     BL,dattxtcolor
	MOV     CX,DATATEND-DATATXT
	LEA     BP,DATATXT
	INT     10h                     ; print "DATA" line
	;             Y           X
	MOV     DX,(YO+2)*256+(XO+15)
	MOV     AH,shortcut
	MOV     AL,'D'                  ; set the 'D' highlighted
	CALL    Print

	;	     Y	      X
	MOV     DX,(24)*256+(79)
	MOV	AH,esccolor
	MOV     AL,' '
	CALL	Print			; fix char on lower right

	;             Y           X
	MOV     DX,(YO+13)*256+(XO+23)
	MOV     AH,gndcolor
	MOV     CX,'18'                 ; print GND and "don't cares"
Pnums:  MOV     AL,CH
	CALL    Print                   ; print 1st number
	INC     DL
	MOV     AL,CL
	CALL    Print                   ; print 2nd number
	MOV     AH,notcare              ; set "don't care" color
	ADD     DL,4                    ; next position
	INC     CL
	CMP     CL,'9'                  ; check for overflow
	JLE     NO_OV
	ADD     CX,00FFh-9              ; 19->20
NO_OV:  CMP     CL,'6'                  ; Have we reached 25 yet?
	JNE     Pnums

	MOV     CX,35                   ; paint 35x'-'
	;             Y           X
	MOV     DX,(YO+14)*256+(XO+24)
	MOV     AL,'-'
RepL:   CALL    Print
	INC     DL
	LOOPW   RepL
	;             Y           X
	MOV     DX,(YO+14)*256+(XO+23)
	MOV     AH,gndcolor             ; dump "GND"
	LEA     BX,GNDtxt
pGND:   MOV     AL,[BX]
	CALL    Print
	INC     DH                      ; next line
	INC     BX
	CMP     AL,'D'
	JNE     pGND
; Ain't ya glad we saved some bytes by not saving it as ASCII? ;)

	MOV	AH,4Ah			; resize memory block
	LEA	BX,ENDOA		; end of anything (this program)
	SHR	BX,4			; new blocksize in paragraphs
	INC	BX
	INT	21h			; free unused memory (just for fun;)
	LEA	SP,OVERWR.STACKTP	; new stack

;
;       Mouse detection and setup
;
	XOR     AX,AX
	INT     33h                     ; Mouse Reset, check if installed
	MOV     OVERWR.MOUSE,AL         ; Mouse-State (-1 = installed)
	TEST    AL,AL
	JZ      noMouse

	PUSH    ES
	MOV     CX,2+1                  ; notify lbutton + movement
;       ES is already set to CS, which is just fine. :-)
	LEA     DX,MouseINT             ; our own mouse-interrupt-handler
	MOV     AX,14h
	INT     33h                     ; Swap Interrupt Subroutines
	MOV     OVERWR.MOUSEIM,CX       ; save old int-mask and address
	MOV     WORD PTR OVERWR.MOUSEI,DX
	MOV     WORD PTR OVERWR.MOUSEI+2,ES
	POP     ES
	CALL    showMOUSE
	LEA     BP,MonTXT
	MOV     CX,MonEND-MonTXT
	JMP     PMtxt
noMouse:
	LEA     BP,MoffTXT
	MOV     CX,MoffEND-MoffTXT
PMtxt:  ;           Y       X
	MOV     DX,(0)*256+(40)
	MOV	BL,titlecolor
	MOV     AX,1300h                ; write string
	MOV     BH,OVERWR.VPAGE
	INT	10h			; print "DATA" line

;
;       READ IN PORT HERE, STORE IN "STATUS", COMPARE TO "PREPORT"
;       AND SET "CHANGED"!
;
DUMPIT: STI                             ; enable interrupts
;
; Mostly a "DUMMY"! We use this to blank the mouse-cursor though...
; (just a DOS call, so Win95 can schedule two instances)
;
	PUSHA
	MOV     AH,2Ch
	INT     21h
	CMP     OVERWR.MOUSE,0
	JE      getONW          ; no mouse-handler there
	BT    	OVERWR.Mbutton,7; we passed (signal it)
	JNC     NoME           	; no mouse-event
	MOV     SEC,DH          ; new "old time" ;)
NoME:   MOV     AL,SEC          ; old time (seconds)
	CMP     DH,AL           ; Did we have an overflow?
	JAE     noOVRF
	ADD     DH,59           ; 1 minute more
noOVRF: SUB     DH,AL
	CMP     DH,BlankTimer   ; Did X seconds expire?
	JB      getONW          ; No, don't blank...
	CALL    hideMOUSE
getONW: POPA
;
; DUMMY-end (Du doof, Du Windoof!;)
;
	CMP     OVERWR.MOUSE,0
	JE      NoMouseAction           ; no mouse-handler there
	BTR     OVERWR.Mbutton,7        ; we passed (signal it)
	JNC     NoMouseAction           ; no mouse-event
	CALL    showMOUSE
NotNec:
;       EVENTHANDLING
	AND     OVERWR.Mbutton,2        ; Left mouse button pressed?
	JZ      NoMouseAction           ; No, just moved it...
	MOV     AX,OVERWR.X
	MOV     BX,OVERWR.Y
	SHR     AX,3                    ; divide by 8
	SHR     BX,3                    ; "
	CMP     AL,60
	JB      noESC
	CMP     BL,24
	JAE     Fini                    ; clicked ESC-txt
noESC:
	CALL    hideMOUSE
	MOV     DL,AL                   ; X
	MOV     DH,BL                   ; Y
	MOV     BH,OVERWR.VPAGE
	MOV     AH,2                    ; set cursor position
	INT     10h
;       MOV     BH,OVERWR.VPAGE
	MOV     AH,8
	INT     10h                     ; read attribute at cursor
	CMP     AH,background           ; attribute at cursor != background
	JE      MouseAction
	CMP     DH,1
	JB      MouseAction             ; Title line?
	CMP     DH,78
	JA      MouseAction             ; Bottom line?
	CMP     DH,12
	JA      lowerP
	SUB     DL,9                    ; "strobe"?
	JE      strobe                  ; MUST BE EQUAL TO JUMP THERE!!!
	CMP     DH,3
	JNE     NotDS
	CMP     DL,55
	JBE     turnD                   ; flip in/out of DATA
NotDS:  MOV     AH,0
lfD:    INC     AH
	SUB     DL,5
	JE      more0                   ; one of eight DATA-bits
	CMP     AH,8
	JBE     lfD
	JMP     MouseAction             ; user clicked an "input"...
lowerP: CMP     DL,12
	JA      chINI
	CMP     DL,DL
	JMP     autofd                  ; "auto_fd" - MUST BE EQU!!!
chINI:  CMP     DL,20
	JB      MouseAction
	CMP     DL,23
	JA      chckS
	CMP     DL,DL                   ; MUST BE EQU TO PROCEED...
	JMP     init
chckS:  CMP     DL,27
	JA      MouseAction
	CMP     DL,DL
	JMP     select                  ; "select_out"
MouseAction:
	CALL    showMOUSE
NoMouseAction:
	XOR     EBX,EBX

	MOV     DX,OVERWR.PORT
	XOR     EAX,EAX
	IN      AL,DX                   ; read data0-7 status
	SHL     AX,1
	OR      BX,AX                   ; proper position in EBX

	INC     DX
	XOR     EAX,EAX
	IN      AL,DX                   ; read status in
	BT      AX,3                    ; check "error_in"
	JNC     err0
	BTS     BX,14                   ; set bit 14
err0:   BT      AX,4                    ; check "select_in"
	JNC     sel0
	BTS     BX,12                   ; becomes bit 12
sel0:   BT      AX,5                    ; check "paperend_in"
	JNC     pap0
	BTS     BX,11                   ; turns into bit 11
pap0:   BT      AX,6                    ; check "ack_in"
	JNC     ack0
	BTS     BX,9                    ; becomes bit 9
ack0:   BT      AX,7                    ; "busy_in"
	JNC     bus0
	BTS     BX,10                   ; turn to bit 10
bus0:   INC     DX
	IN      AL,DX                   ; read control feedback
	BT      AX,0                    ; strobe_out?
	JNC     str0
	BTS     BX,0                    ; lame way to copy a bit ;)
str0:   BT      AX,1                    ; autofd_out?
	JNC     aut0
	BTS     BX,13                   ; -> bit 13
aut0:   BT      AX,2                    ; init_out?
	JNC     ini0
	BTS     EBX,15                  ; -> bit 15
ini0:   BT      AX,3                    ; select_out?
	JNC     sou0
	BTS     EBX,16                  ; -> bit 16
sou0:   BT      AX,5                    ; tristated for input (bi-port)?
	JNC     ddi0
	BTS     EBX,17                  ; -> bit 17
	AND     DWORD PTR INOUT,11111111111111111111111000000001b
	JMP     setTin
ddi0:   OR      DWORD PTR INOUT,111111110b
setTin: XOR     EBX,INVERT              ; flip inverted bits
	MOV     OVERWR.STATUS,EBX       ; store status
	MOV     EAX,OVERWR.PREPORT      ; last status
	BTR     DWORD PTR INVERT,25     ; check if we pass for 1st time
	JNC     not1st                  ; if we do,
	MOV     EAX,EBX                 ; PREPORT becomes NOT(STATUS)
	NOT     EAX                     ; so everything is painted once
not1st: MOV     OVERWR.PREPORT,EBX
	XOR     EBX,EAX

	BT      EBX,17                  ; test for data-switch
	JNC     nochng
	OR      EBX,111111110b          ; data turned from i/o to o/i

	PUSHA                           ; make input/output become output/input
	LEA     BX,DAT0
	MOV     CX,8
fldat:  MOV     DL,80h
	BT      OVERWR.STATUS,17
	JC      is_inp
	OR      [BX],DL                 ; flip shortcuts on/off
	JMP     is_otp
is_inp: NOT     DL
	AND     [BX],DL
is_otp: ADD     BX,DAT1-DAT0
	LOOP    fldat
	POPA

nochng: MOV     OVERWR.CHANGED,EBX      ; store only changed

	XOR     ECX,ECX                 ; start with bit 1
	INC     CL
	;             Y           X
	MOV     DX,(YO+11)*256+(XO+1)   ; starting position

DPaint: MOV     EAX,OVERWR.CHANGED
	PUSH    CX
	DEC     CX
	BT      EAX,ECX
	POP     CX
	JNC     over                    ; don't paint, didn't change...

	MOV     EAX,OVERWR.STATUS
	CALL    chkbit
	MOV     AH,low0
	JZ      DumpN
	MOV     AH,high5
DumpN:  PUSH    ECX                     ; dump numbers
	PUSH    DX
	CMP     CL,9
	JLE     oneC
	INC     CH
	SUB     CL,10
oneC:   XOR     CX,'00'                 ; build number from CH
	CMP     CH,'0'                  ; no leading 0's
	JE      dump2
	MOV     AL,CH
	CALL    Print                   ; print 1st number
	INC     DL
dump2:  MOV     AL,CL
	CALL    Print                   ; print 2nd number
	POP     DX
	POP     ECX
; next: dump arrows
	PUSH    DX
	PUSH    AX
	MOV     EAX,INOUT
	CALL    chkbit                  ; check if input or output
	POP     AX
	JE      is_in
	CALL    updown                  ; cursor up or down
	MOV     AL,''
	CALL    Print
	CALL    updown
	JG      adown
	MOV     AL,''                  ; output on upper line
	JMP     preDL
adown:  MOV     AL,''                  ; output on lower line
	JMP     preDL
is_in:  CALL    updown
	JLE     aup
	MOV     AL,''                  ; input on lower line
	JMP     prenix
aup:    MOV     AL,''                  ; input on upper line
prenix: CALL    Print
	CALL    updown
	MOV     AL,''
preDL:  CALL    Print
; next: dump pin-text
	LEA     DI,PINS
	PUSH    CX
	CLD                             ; clear direction
pckPIN: PUSH    CX
	PUSH    AX
	XOR     CX,CX
	DEC     CX
	XOR     AL,AL                   ; search for 0
	REPNE   SCASB
	POP     AX
	POP     CX
	DEC     CX
	JNZ     pckPIN
	POP     CX
	CALL    updown
	JMP     inhere
ReFet:  INC     DI
	CMP     AH,low0
	JE      Dany
	CMP     AL,'A'
	JL      Dany                    ; got a number there
	AND     AL,11011111b            ; make it uppercase if high
Dany:   PUSH    AX
	BTR     AX,7                    ; check for shortcut
	JNC     noScut
	CMP     AL,'A'
	JL      isnum                   ; got a number there
	AND     AL,11011111b            ; make it uppercase
isnum:  MOV     AH,shortcut
noScut: CALL    Print
	CALL    updown
	POP     AX
inhere: MOV     AL,[DI]                 ; fetch next char
	TEST    AL,AL
	JNE     ReFet                   ; next char if not null
	POP     DX
over:   ADD     DL,5                    ; next one
	INC     CL
	CMP     CL,14
	JNE     Dchk
	;             Y           X
	MOV     DX,(YO+13)*256+(XO+3)   ; starting position
Dchk:   CMP     CL,18
	JNE     DPaint

	CLI                             ; Hey! This's my key. ;)
	MOV     AH,1
	INT     16h                     ; get key-stroke status
	JZ      DUMPIT                  ; STI follows there
	MOV     AH,0
	INT     16h                     ; wait for key
	STI                             ; enable interrupts

;       key was pressed - hide mouse cursor
	CALL    hideMOUSE

placeKey:
	CMP     AH,14h                  ; T?
strobe: MOV     BL,1                    ; strobe
	JE      FlipControl
	CMP     AH,1Eh                  ; A?
autofd: MOV     BL,2                    ; autofd
	JE      FlipControl
	CMP     AH,17h                  ; I?
init:   MOV     BL,4                    ; init
	JE      FlipControl
	CMP     AH,1Fh                  ; S?
select: MOV     BL,8                    ; select_out
	JE      FlipControl

	CMP     AH,2                    ; 1-9?
	JL      noNumber
	CMP     AH,0Bh
	JG      noNumber
	JNE     more0                   ; is not null
	MOV     AH,1                    ; convert 0
more0:  XOR     BL,BL
	DEC     AH
	MOV     AL,DAT0
	AND     AL,80h                  ; Is it set to output?
	JE      DUMPIT                  ; No, ignore!
	SHR     AX,8
	BTS     BX,AX
	PUSHA
	MOV     DX,OVERWR.PORT
	JMP     outit
noNumber:
	CMP     AH,20h                  ; D?
	JNE     chkESC
turnD:  MOV     BL,32                   ; turn DAT
	JMP     FlipControl

chkESC: CMP     AH,01h                  ; ESC?
	JNE     DUMPIT
;
;       restore previous mouse interrupt
;
Fini:   CMP     OVERWR.MOUSE,0
	JE      Ende                    ; nothing to restore, wasn't there

	MOV     CX,OVERWR.MOUSEIM       ; old int-mask and address
;       MOV     DX,OVERWR.MOUSEI WORD PTR
;       MOV     ES,OVERWR.MOUSEI+2 WORD PTR
	LES     DX,OVERWR.MOUSEI
	MOV     AX,14h
	INT     33h
	CALL    hideMOUSE               ; hide mouse cursor

Ende:   MOV     AL,OVERWR.OLDmode       ; restore old video mode
	MOV     AH,0
	INT     10h
	MOV     AH,1                    ; restore old cursor
	MOV     CX,OVERWR.CURSOR
	INT     10h

	MOV	AX,1003h		; toggle blink-flag
	MOV	BL,OVERWR.BLINK		; set to intensity rather than blinking
	AND	BL,32
	INT	10h

	MOV	AX,1012h		; set colors
	XOR	BX,BX
	MOV	CX,16			; set color registers
	LEA	DX,OVERWR.COLORMA
	INT	10h

	MOV	AX,1002h		; set old palette and border
	LEA	DX,OVERWR.PALETTA
	INT	10h

	MOV     DL,OVERWR.breakf
	MOV     AX,3301h
	INT     21h                     ; reset break-flag to old state

	MOV	AX,4C00h		; terminate without error
	INT	21h			; THE END!
;--------------------------------------------------------------------------

FlipControl:
	PUSHA
	MOV     DX,OVERWR.PORT
	INC     DX
	INC     DX                      ; control out
outit:  IN      AL,DX
	XOR     AL,BL
	OUT     DX,AL
	POPA
	JMP     DUMPIT

;
;       Mouse-Interrupt-Handler
;
MouseINT:
	CMP     CS:active,0     	; Did we already enter once?
	JNE     MIend                   ; Yes! Let the other instance do its work...
	INC	CS:active		; mark routine as busy
	MOV     CS:OVERWR.X,CX          ; horizontal cursor position
	MOV     CS:OVERWR.Y,DX          ; vertikal    "
	MOV     CS:OVERWR.Mbutton,AX    ; button state
	OR      CS:OVERWR.Mbutton,80h   ; we passed (signal it)
	DEC	CS:active		; no longer busy
MIend:  RETF                            ; back to mouse-driver

chkbit: PUSH    EBX                     ; Heh, bit-instructions?
	XOR     EBX,EBX                 ; Maybe next time... :-)
	INC     EBX
	DEC     CL
	SHL     EBX,CL
	INC     CL
	AND     EBX,EAX
	POP     EBX
	RET

updown: CMP     CL,13                   ; bit 1-13?
	JG      down
	PUSHF
	DEC     DH
	JMP     uout
down:   PUSHF
	INC     DH
uout:   POPF
	RET

; x-position in DL, y-pos. in DH
; attribute in AH, char in AL
; everything is preserved (condom procedure)
Print:  PUSHA                           ; Well, this "8-bit processor" lacks
	PUSH    AX                      ; of registers!
	MOV     AH,2                    ; set cursor position
	MOV     BH,OVERWR.VPAGE
	INT     10h
	POP     AX

;       MOV     BH,OVERWR.VPAGE         ; Do you know your BIOS?
	MOV     BL,AH
	MOV     AH,9                    ; write char
	MOV     CX,1                    ; number of chars to write
	INT     10h
	POPA
	RET

CMDerr: LEA     DX,ERRtxt
wrPORT: MOV     AH,9                    ; write string
	INT     21h
	RETN

hideMOUSE:
	PUSHA
	MOV     AX,2            ; hide Mouse
	MOV     BL,0
dMOUSE: CMP     OVERWR.MOUSE,0
	JE      doNOTH          ; no mouse-handler there
	CMP     MOUSESTATE,BL
	JE      doNOTH          ; already hidden
	MOV     MOUSESTATE,BL
	INT     33h             ; hide mouse
doNOTH: POPA
	RETN
showMOUSE:
	PUSHA
	MOV     AX,1            ; hide Mouse
	MOV     BL,1
	JMP     dMOUSE

active          DB      0               ; 1 if int-routine is busy
SEC             DB      0               ; seconds (for blanking the mouse)
MOUSESTATE      DB      0               ; state of mouse (displayed/hidden)

ERRtxt  DB      0Dh,0Ah,'Command line error: Please use only "1", "2" or "3" '
	DB      '(port number) as argument.',0Dh,0Ah,'$'
wrPtxt  DB      0Dh,0Ah,'Error: No such port.',0Dh,0Ah,'$'

GNDtxt  DB      '˺GND'

PTITLE  DB      ' PARport MONITOR V1.02 '
	DB      'accessing: LPT'
PORTNR  DB      '  -'                           ; port number goes in here
TITLEEND        LABEL   WORD

MonTXT  DB      ' MOUSE-HANDLER INSTALLED '
MonEND          LABEL   WORD
MoffTXT DB      ' NO MOUSE-DRIVER '
MoffEND         LABEL   WORD

ESCTXT  DB      ' press ESC to abort'
ESCEND  LABEL   WORD

DATATXT DB      'switch DATA to input  output'       ; HOTKEY: D
DATATEND        LABEL WORD

PINS    DB      0                               ; Marx begin of table
	DB      'ebor',80h OR 't','s_',0        ; HOTKEY: T
DAT0    DB      '0' OR 80h,'atad',0             ; HOTKEY: 0
DAT1    DB      '1' OR 80h,'atad',0             ; HOTKEY: 1
	DB      '2' OR 80h,'atad',0             ; HOTKEY: 2
	DB      '3' OR 80h,'atad',0             ; HOTKEY: 3
	DB      '4' OR 80h,'atad',0             ; HOTKEY: 4
	DB      '5' OR 80h,'atad',0             ; HOTKEY: 5
	DB      '6' OR 80h,'atad',0             ; HOTKEY: 6
	DB      '7' OR 80h,'atad',0             ; HOTKEY: 7
	DB      'kca',0                         ; input only
	DB      'ysub_',0                       ; input only
	DB      'dnerepap',0                    ; input only
	DB      'nitceles!',0                   ; input only
	DB      '_','a' OR 80h,'utofd',0        ; HOTKEY: A
	DB      'error',0                       ; input only
	DB      80h OR 'i','nit',0              ; HOTKEY: I
	DB      '_',80h OR 's','elect',0        ; HOTKEY: S

			; |SEL          |STROBE
INOUT   DD              11010000111111111b      ; input(0)\output(1) state
INVERT  DD  11111111110010010010000000001b      ; active low(1)\high(0)

;
;	DON'T EDIT THIS! CHANGE COLORMAP INSTEAD...
;
PALETTE DB	0			; background
	DB	1
	DB	2
	DB	3
	DB	4
	DB	5
	DB	6
	DB	7
	DB	8
	DB	9
	DB	10
	DB	11
	DB	12
	DB	13
	DB	14
	DB	15
	DB	0			; palette

IF	COLOR
;*******************************************************************
;*		    COLORS FOR A COLOR DISPLAY			   *
;*******************************************************************
;
;	CHANGE COLORS HERE,
;	BUT MAKE SURE THAT NO COLOR MATCHES THE BACKGROUND-COLOR!
;
;		red,	green	blue
COLORMP DB       0,     10,     0       ; background
        DB      42,     42,     0       ; title background
        DB       0,     0,     34       ; title front
        DB      30,     0,      0       ; high bg
        DB      63,     5,      5       ; high foreground
        DB      30,     30,     30      ; low bg
        DB      10,     10,     10      ; low fg
	DB	27,	27,	27	; not care/GND background
	DB	14,	14,	14	; not care fg
	DB	0,	0,	0	; GND fg
        DB      25,     25,     0       ; shortcut bg
        DB      60,     60,     10      ; shortcut fg
        DB      30,     18,     18      ; DAT-txt bg
        DB      56,     40,     40      ; DAT-txt fg
        DB      20,     10,     3       ; ESC-txt bg
        DB      48,     38,     5       ; ESC-txt fg

ELSE
;*******************************************************************
;*		 COLORS FOR A MONOCHROME DISPLAY		   *
;*******************************************************************
;
;	CHANGE COLORS HERE,
;	BUT MAKE SURE THAT NO COLOR MATCHES THE BACKGROUND-COLOR!
;
;		r-gray,	g-gray	b-gray
COLORMP DB	20,	20,	20	; background
	DB	12,	12,	12	; title background
	DB	54,	54,	54	; title front
	DB	49,	49,	49	; high bg
	DB	63,	63,	63	; high foreground
	DB	0,	0,	0	; low bg
	DB	32,	32,	32	; low fg
	DB	27,	27,	27	; not care/GND background
	DB	14,	14,	14	; not care fg
	DB	0,	0,	0	; GND fg
	DB	63,	63,	63	; shortcut bg
	DB	10,	10,	10	; shortcut fg
	DB	49,	49,	49	; DAT-txt bg
	DB	6,	6,	6	; DAT-txt fg
	DB	58,	58,	58	; ESC-txt bg
	DB	3,	3,	3	; ESC-txt fg
ENDIF

ENDOA	EQU	THIS BYTE
START	ENDP
SEGALL  ENDS
	END     START

